//+------------------------------------------------------------------+
//|                                                      h_TS_BW.mqh |
//|                                                         olyakish |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "olyakish"
#property link      "http://www.mql5.com"



#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\PositionInfo.mqh>
#include<Trade\HistoryOrderInfo.mqh>
//       
enum type_support_position
  {
   Not_used=-1,               //       
   Trailing_On_Lips=0,        //     
   Trailing_On_Teeth=1,       //     
   Trailing_On_Jaws=2,        //     
   Close_On_Lips=3,           //        
   Close_On_Teeth=4,          //        
   Close_On_Jaw=5,            //        
   Close_Out_Alligator=6      //      
  };
//+------------------------------------------------------------------+
//|         C_TS_BW                                    |
//+------------------------------------------------------------------+

class C_TS_BW
  {
private:
   datetime          time[1];                                  //    
   datetime          last_time[1];                             //    (     )
   int               h_alligator,h_fractals,h_ao,h_ac;              //  
   string            m_Symbol;                                      //    
   ENUM_TIMEFRAMES   m_Period;                                      //      
   CTrade            exp_trade;                                     //      
   CSymbolInfo       s_info;                                        //      
   CPositionInfo     pos_info;                                      //      
   CHistoryOrderInfo h_info;                                        //     
   bool              FindSignal_1_dimension(int type,double&price_out[],datetime &time_out[]);  //     
   bool              FindSignal_2_dimension(int type,int sub_type,double&price_out[],datetime &time_out[]);  //     
   bool              FindSignal_3_dimension(int type,int sub_type,double&price_out[],datetime &time_out[]);  //      
   bool              FindSignal_4_dimension(int type,int sub_type,double&price_out[],datetime &time_out[]);  //      
   bool              FindSignal_5_dimension(int type,int sub_type,double&price_out[],datetime &time_out[]);  //     
   bool              CheckForTradeSignal(int dimension,int type,int sub_type,double&price_out[],datetime &time_out[]);  //        
   bool              SendOrder(ENUM_ORDER_TYPE type,double&price_out[],datetime &time_out[],string comment); //    
   bool              CopyIndValue(int type,int countValue);
   ulong             CalcMagic(ulong  &magic);           //         
   double            High[],Low[],Close[],AO_color[],AO_value[],AC_color[],AC_value[];      //     
   double            lips[],teeth[],jaw[];                       //       
   double            Lot; //   
   double            StopLoss;            //    
   ulong             Magic;  //    

   struct l_signals         ////  
     {
      double            fractal_up[1];  //       ( )
      double            fractal_dn[1];  //       ( )
      double            bludce_up[1];   //     ""    ( )
      double            bludce_dn[1];   //     ""    ( )
      double            cross_zero_up[1]; //     "  "    ( )
      double            cross_zero_dn[1]; //     "  "    ( )
      double            ac_2_bars_up[1];  //     "      "    ( )
      double            ac_2_bars_dn[1];  //     "      "    ( )
      double            ac_3_bars_up[1];  //     "      "    ( )
      double            ac_3_bars_dn[1];  //     "      "    ( )
      double            zone_up[1];       //     " "    (  ,    Close)
      double            zone_dn[1];       //     " "    (  ,    Close)
      double            zone_5_trall_green[1]; //     "       "     (    )
      double            zone_5_trall_red[1];   //     "       "     (    )
      double            five_dimension_2_bars_up[1]; //     "    (  )"     (    High)
      double            five_dimension_3_bars_up[1]; //     "    (  )"     (    High)
      double            five_dimension_2_bars_dn[1]; //     "    (  )"     (    Low)
      double            five_dimension_3_bars_dn[1]; //     "    (  )"     (    Low)
      bool              alligator_trend[2];          //       

      datetime          fractal_up_time[1]; //        ( )
      datetime          fractal_dn_time[1]; //        ( )
      datetime          bludce_up_time[1];  //     ""    ( )
      datetime          bludce_dn_time[1];  //     ""    ( )
      datetime          cross_zero_up_time[1]; //      "  "    ( )
      datetime          cross_zero_dn_time[1]; //      "  "    ( )
      datetime          ac_2_bars_up_time[1]; //      "      "    ( )
      datetime          ac_2_bars_dn_time[1]; //      "      "    ( )
      datetime          ac_3_bars_up_time[1]; //      "      "    ( )
      datetime          ac_3_bars_dn_time[1]; //      "      "    ( )
      datetime          zone_up_time[1];      //      " "    (  ,    Close)
      datetime          zone_dn_time[1];      //      " "    (  ,    Close)
      datetime          five_dimension_2_bars_up_time[1]; //      "       "     (    )
      datetime          five_dimension_3_bars_up_time[1]; //      "    (  )"     (    High)
      datetime          five_dimension_2_bars_dn_time[1]; //      "    (  )"     (    Low)
      datetime          five_dimension_3_bars_dn_time[1]; //      "    (  )"     (    Low)
      void              l_signals_clear(ENUM_POSITION_TYPE type) //      
        {
         alligator_trend[0]=false;
         alligator_trend[1]=false;
         if(type==POSITION_TYPE_BUY)
           {
            fractal_up[0]=-1;
            bludce_up[0]=-1;
            cross_zero_up[0]=-1;
            ac_2_bars_up[0]=-1;
            ac_3_bars_up[0]=-1;
            zone_up[0]=-1;
            zone_5_trall_green[0]=-1;
            five_dimension_2_bars_up[0]=-1;
            five_dimension_3_bars_up[0]=-1;

            fractal_up_time[0]=-1;
            bludce_up_time[0]=-1;
            cross_zero_up_time[0]=-1;
            ac_2_bars_up_time[0]=-1;
            ac_3_bars_up_time[0]=-1;
            zone_up_time[0]=-1;
            five_dimension_2_bars_up_time[0]=-1;
            five_dimension_3_bars_up_time[0]=-1;
           }
         if(type==POSITION_TYPE_SELL)
           {
            fractal_dn[0]=-1;
            bludce_dn[0]=-1;
            cross_zero_dn[0]=-1;
            ac_2_bars_dn[0]=-1;
            ac_3_bars_dn[0]=-1;
            zone_dn[0]=-1;
            zone_5_trall_red[0]=-1;
            five_dimension_2_bars_dn[0]=-1;
            five_dimension_3_bars_dn[0]=-1;

            fractal_dn_time[0]=-1;
            bludce_dn_time[0]=-1;
            cross_zero_dn_time[0]=-1;
            ac_2_bars_dn_time[0]=-1;
            ac_3_bars_dn_time[0]=-1;
            zone_dn_time[0]=-1;
            five_dimension_2_bars_dn_time[0]=-1;
            five_dimension_3_bars_dn_time[0]=-1;
           }
        }
     };
   l_signals         last_signals;
   //     
   struct l_trade
     {
      datetime          fractal_up;
      datetime          fractal_dn;
      datetime          ao_blydce;
      datetime          ao_cross_zero;
      datetime          ac_2_bars;
      datetime          ac_3_bars;
      datetime          zone;
      datetime          five_dimension;
     };
   l_trade           last_trade;

   struct            s_input_parametrs //    
     {
      double            lot;                //    ()
      type_support_position support_position; //     
      int               alligator_jaw_period;//:   
      int               alligator_jaw_shift;//:   
      int               alligator_teeth_period;//:   
      int               alligator_teeth_shift;//:   
      int               alligator_lips_period;//:   
      int               alligator_lips_shift;//:   
      int               max_4_dimension_zone;  //             
      bool              add_1_dimension;  //    
      bool              add_2_dimension_bludce;  //     " ()"
      bool              add_2_dimension_cross_zero;  //     "   ()"
      bool              add_3_dimension_use_2_bars;  //     "  0,   0" ( 2 )
      bool              add_3_dimension_use_3_bars;  //     "  0,   0" ( 3 )
      bool              add_4_dimension_zone;  //         
      bool              add_5_dimension;       //       
      bool              trall_4_dimension;  //    5     
      bool              agress_trade_mm;  //      
     };
   s_input_parametrs inp_param;        //    

public:
   void              C_TS_BW(); // 

   s_input_parametrs inp_param_tmp;    //    (     )

   struct s_actual_action
     {
      bool              fractal_open_buy;
      bool              fractal_add_buy;
      bool              fractal_revers_buy_to_sell;
      bool              fractal_open_sell;
      bool              fractal_add_sell;
      bool              fractal_revers_sell_to_buy;
      bool              ao_bludce_buy;
      bool              ao_bludce_sell;
      bool              ao_cross_zero_buy;
      bool              ao_cross_zero_sell;
      bool              ac_2_bar_buy;
      bool              ac_2_bar_sell;
      bool              ac_3_bar_buy;
      bool              ac_3_bar_sell;
      bool              zone_buy;
      bool              zone_sell;
      bool              line_balance_2_bar_buy;
      bool              line_balance_2_bar_sell;
      bool              line_balance_3_bar_buy;
      bool              line_balance_3_bar_sell;
      bool              position_close;
      void              init()
        {
         fractal_open_buy=false;
         fractal_add_buy=false;
         fractal_revers_buy_to_sell=false;
         fractal_open_sell=false;
         fractal_add_sell=false;
         fractal_revers_sell_to_buy=false;
         ao_bludce_buy=false;
         ao_bludce_sell=false;
         ao_cross_zero_buy=false;
         ao_cross_zero_sell=false;
         ac_2_bar_buy=false;
         ac_2_bar_sell=false;
         ac_2_bar_buy=false;
         ac_3_bar_sell=false;
         zone_buy=false;
         zone_sell=false;
         line_balance_2_bar_buy=false;
         line_balance_2_bar_sell=false;
         line_balance_3_bar_buy=false;
         line_balance_3_bar_sell=false;
         position_close=false;
        }
     };
   s_actual_action   actual_action;
   bool              Init(string Symbol_for_trade,ENUM_TIMEFRAMES Period_for_trade,s_input_parametrs  &inp_param_tmp); //  
   bool              NewBar();//       \
   void              CheckSignal();  //  
   void              CheckActionOnTick();  //      
   void              TrailingStop();  //  
   void              TradeActualSignals();//   ()
   void              SetStopLoss(double  &stoploss);  //   

                                                      //   ( !external         ext_lot)
   void              CalcLot(bool external,double ext_lot,int type);

  };
//+------------------------------------------------------------------+ 

C_TS_BW::C_TS_BW(void)
  {
  }
//+------------------------------------------------------------------+
//|                                               +
//|       Symbol_for_trade -                        +
//|       Period_for_trade-                  +
//|      false -   
//+------------------------------------------------------------------+
bool C_TS_BW::Init(string Symbol_for_trade,ENUM_TIMEFRAMES Period_for_trade,s_input_parametrs  &inp_param_tmp)
  {
   inp_param=inp_param_tmp;
   time[0]=-1;                                  //    
   last_time[0]=-2;
   m_Symbol=Symbol_for_trade;
   m_Period=Period_for_trade;
   Lot=inp_param.lot;
   StopLoss=-1;
   Magic=-1;
//  
   h_alligator=iAlligator(m_Symbol,m_Period,inp_param.alligator_jaw_period,0,inp_param.alligator_teeth_period,0,inp_param.alligator_lips_period,0,MODE_SMMA,PRICE_MEDIAN);
   if(h_alligator==INVALID_HANDLE){return(false);}
   h_fractals=iFractals(m_Symbol,m_Period);
   if(h_fractals==INVALID_HANDLE){return(false);}
   h_ao=iAO(m_Symbol,m_Period);
   if(h_ao==INVALID_HANDLE){return(false);}
   h_ac=iAC(m_Symbol,m_Period);
   if(h_ac==INVALID_HANDLE){return(false);}
//      
   ArraySetAsSeries(AO_color,true);
   ArraySetAsSeries(AO_value,true);
   ArraySetAsSeries(AC_color,true);
   ArraySetAsSeries(AC_value,true);
   ArraySetAsSeries(High,true);
   ArraySetAsSeries(Low,true);
   ArraySetAsSeries(Close,true);
   ArraySetAsSeries(lips,true);
   ArraySetAsSeries(teeth,true);
   ArraySetAsSeries(jaw,true);
//   
   s_info.Name(m_Symbol);       //    
   s_info.Refresh();            //    
   return(true);
  }
//+------------------------------------------------------------------+
//|     (   true  false               |
//+------------------------------------------------------------------+
bool C_TS_BW::NewBar(void)
  {
   int copy=-1;
   copy=CopyTime(m_Symbol,m_Period,0,1,time);
   if(copy>0 && time[0]>last_time[0])
     {
      last_time[0]=time[0];
      return(true);
     }
   else
     {return(false);}
  }
//+------------------------------------------------------------------+
//       5-  
//+------------------------------------------------------------------+
void C_TS_BW::CheckSignal(void)
  {
   CopyClose(m_Symbol,m_Period,0,3,Close);
   datetime tmp_timer[1];
   last_signals.alligator_trend[0]=false;
   last_signals.alligator_trend[1]=false;
   CopyIndValue(0,2);  //     
   CopyIndValue(2,10);  //  
   CopyIndValue(3,10);  //    



   bool select_pos=pos_info.Select(m_Symbol);
   if(select_pos)
     {
      switch(inp_param.support_position)
        {
         case 3:        //Close_On_Lips=3,           //        
           {
            if(((ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY && Close[1]<lips[1]) ||
               ((ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL && Close[1]>lips[1]))
              {actual_action.position_close=true;}
            break;
           }
         case 4:           //Close_On_Teeth=4,          //        
           {
            if(((ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY && Close[1]<teeth[1]) ||
               ((ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL && Close[1]>teeth[1]))
              {actual_action.position_close=true;}
            break;
           }
         case 5:           //Close_On_Jaw=5             //             
           {
            if(((ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY && Close[1]<jaw[1]) ||
               ((ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL && Close[1]>jaw[1]))
              {actual_action.position_close=true;}
            break;
           }
         case 6:           //Close_Out_Alligator=6            
           {
            if(((ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY && Close[1]<MathMin(jaw[1],MathMin(lips[1],teeth[1]))) ||
               ((ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL && Close[1]>MathMax(jaw[1],MathMax(lips[1],teeth[1]))))
              {actual_action.position_close=true;}
            break;
           }           
        }
     }

   last_signals.l_signals_clear(POSITION_TYPE_BUY);
   last_signals.l_signals_clear(POSITION_TYPE_SELL);
//---    
   if(lips[0]>teeth[0] && teeth[0]>jaw[0]){last_signals.alligator_trend[0]=true;}
   if(lips[0]<teeth[0] && teeth[0]<jaw[0]){last_signals.alligator_trend[1]=true;}   
   FindSignal_1_dimension(0,last_signals.fractal_up,last_signals.fractal_up_time);  //     
   FindSignal_1_dimension(1,last_signals.fractal_dn,last_signals.fractal_dn_time);  //     
   if(select_pos && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY && last_signals.alligator_trend[0])
     {
      FindSignal_2_dimension(0,0,last_signals.cross_zero_up,last_signals.cross_zero_up_time);  //      ( )
      FindSignal_2_dimension(0,1,last_signals.bludce_up,last_signals.bludce_up_time);  //    ( )
      FindSignal_3_dimension(0,0,last_signals.ac_2_bars_up,last_signals.ac_2_bars_up_time);  //  AC ( )     
      FindSignal_3_dimension(0,1,last_signals.ac_3_bars_up,last_signals.ac_3_bars_up_time);  //  AC ( )     
      FindSignal_4_dimension(0,0,last_signals.zone_up,last_signals.zone_up_time);            //       
      FindSignal_4_dimension(0,1,last_signals.zone_5_trall_green,tmp_timer);            //          
      FindSignal_4_dimension(0,2,last_signals.zone_up,last_signals.zone_up_time);            //            
      FindSignal_5_dimension(0,0,last_signals.five_dimension_2_bars_up,last_signals.five_dimension_2_bars_up_time);            //        (2 )
      FindSignal_5_dimension(0,1,last_signals.five_dimension_3_bars_up,last_signals.five_dimension_3_bars_up_time);            //        (3 )      
     }
   if(select_pos && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL && last_signals.alligator_trend[1])
     {
      FindSignal_2_dimension(1,0,last_signals.cross_zero_dn,last_signals.cross_zero_dn_time);  //      ( )
      FindSignal_2_dimension(1,1,last_signals.bludce_dn,last_signals.bludce_dn_time);  //    ( )
      FindSignal_3_dimension(1,0,last_signals.ac_2_bars_dn,last_signals.ac_2_bars_dn_time);  //  AC ( )     
      FindSignal_3_dimension(1,1,last_signals.ac_3_bars_dn,last_signals.ac_3_bars_dn_time);  //  AC ( )     
      FindSignal_4_dimension(1,0,last_signals.zone_dn,last_signals.zone_dn_time);            //       
      FindSignal_4_dimension(1,1,last_signals.zone_5_trall_red,tmp_timer);            //                
      FindSignal_4_dimension(1,2,last_signals.zone_dn,last_signals.zone_dn_time);            //             
      FindSignal_5_dimension(1,0,last_signals.five_dimension_2_bars_dn,last_signals.five_dimension_2_bars_dn_time);            //        (2 )   
      FindSignal_5_dimension(1,1,last_signals.five_dimension_3_bars_dn,last_signals.five_dimension_3_bars_dn_time);            //        (3 )
     }
  }
//+------------------------------------------------------------------+
//      ( )
//+------------------------------------------------------------------+
void C_TS_BW::TrailingStop(void)
  {
   bool select=pos_info.Select(m_Symbol);
   if(select && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY
      && last_signals.zone_5_trall_green[0]>0 && inp_param.trall_4_dimension)
     {StopLoss=last_signals.zone_5_trall_green[0];}
   if(select && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL
      && last_signals.zone_5_trall_red[0]>0 && inp_param.trall_4_dimension)
     {StopLoss=last_signals.zone_5_trall_red[0];}
   if(select && StopLoss<0)
     {
      switch(inp_param.support_position)
        {
         case -1:       //Not_used=-1,               //       
           {break;}
         case 0:        //Trailing_On_Lips=0,        //     
           {StopLoss=lips[0];break;}
         case 1:        //Trailing_On_Teeth=1,       //     
           {StopLoss=teeth[0];break;}
         case 2:       //Trailing_On_Jaws=2,        //     
           {StopLoss=jaw[0];break;}
        }
     }

//---
   if(StopLoss>0 && 
      ((pos_info.StopLoss()+s_info.Point()<StopLoss && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY && StopLoss<Close[0]-(s_info.StopsLevel()+s_info.Spread()*2)*s_info.Point()) || //     
      (((pos_info.StopLoss()-s_info.Point()>StopLoss && pos_info.StopLoss()>0) || (pos_info.StopLoss()<s_info.Point()*5)) && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL && StopLoss>Close[0]+(s_info.StopsLevel()+s_info.Spread()*2)*s_info.Point()))) //     
     {
      //MathSrand((int)TimeCurrent());
      //string nameojb="stop"+(string) MathRand();
      //ResetLastError();
      //datetime t1[1];
      //CopyTime(m_Symbol,m_Period,0,1,t1);
      //bool draw=ObjectCreate(0,nameojb,OBJ_ARROW_STOP,0,t1[0],StopLoss);
      //Print(nameojb," ",(string)draw,GetLastError());

      if(exp_trade.PositionModify(m_Symbol,NormalizeDouble(StopLoss,s_info.Digits()),pos_info.TakeProfit()))
        {StopLoss=-1.0;}
     }

   StopLoss=-1.0;

  }
//+------------------------------------------------------------------+
//      
//+------------------------------------------------------------------+
void C_TS_BW::TradeActualSignals(void)
  {
   s_info.Refresh();            //    
   if(actual_action.position_close)
     {
      if(exp_trade.PositionClose(m_Symbol,-1))
        {actual_action.position_close=false;}
     }
   if(actual_action.fractal_open_buy || actual_action.fractal_add_buy || actual_action.fractal_revers_sell_to_buy) //         
     {
      if(Lot<0 && actual_action.fractal_open_buy){last_signals.zone_5_trall_green[0]=-1;} //    -   
                                                                                          //if(Lot<0 && actual_action.fractal_add_buy){} //     Buy-   
      if(Lot<0 && actual_action.fractal_revers_sell_to_buy){last_signals.zone_5_trall_green[0]=-1;} //     Sell -    
                                                                                                    //if(Lot>0)
        {
         last_trade.fractal_up=last_signals.fractal_up_time[0];
         if(SendOrder(ORDER_TYPE_BUY,last_signals.fractal_up,last_signals.fractal_up_time,"TC_BW_fr_"+TimeToString(last_signals.fractal_up_time[0])))
           {
            actual_action.fractal_open_buy=false;
            actual_action.fractal_add_buy=false;
            actual_action.fractal_revers_sell_to_buy=false;
            return;
           }
        }
     }
   if(actual_action.fractal_open_sell || actual_action.fractal_add_sell || actual_action.fractal_revers_buy_to_sell) //         
     {
      if(Lot<0 && actual_action.fractal_open_sell){last_signals.zone_5_trall_red[0]=-1;} //    -   
                                                                                         //if(Lot<0 && actual_action.fractal_add_sell){} //     Sell-   
      if(Lot<0 && actual_action.fractal_revers_buy_to_sell){last_signals.zone_5_trall_red[0]=-1;} //     Buy -    
                                                                                                  //if(Lot>0)
        {
         last_trade.fractal_dn=last_signals.fractal_dn_time[0];
         if(SendOrder(ORDER_TYPE_SELL,last_signals.fractal_dn,last_signals.fractal_dn_time,"TC_BW_fr"+TimeToString(last_signals.fractal_dn_time[0])))
           {
            actual_action.fractal_open_sell=false;
            actual_action.fractal_add_sell=false;
            actual_action.fractal_revers_buy_to_sell=false;
            return;
           }
        }
     }
//---  2-5  
//---         
   if(actual_action.ao_bludce_buy) //          ""
     {
      last_trade.ao_blydce=last_signals.bludce_up_time[0];
      if(SendOrder(ORDER_TYPE_BUY,last_signals.bludce_up,last_signals.bludce_up_time,"TC_BW_bl_"+TimeToString(last_signals.bludce_up_time[0])))
        {actual_action.ao_bludce_buy=false;return;}
     }
//---             
   if(actual_action.ao_cross_zero_buy) //          "  "
     {
      last_trade.ao_cross_zero=last_signals.cross_zero_up_time[0];
      if(SendOrder(ORDER_TYPE_BUY,last_signals.cross_zero_up,last_signals.cross_zero_up_time,"TC_BW_cz_"+TimeToString(last_signals.cross_zero_up_time[0])))
        {actual_action.ao_cross_zero_buy=false;return;}
     }
//--- 2-      
   if(actual_action.ac_2_bar_buy) //         C "  "
     {
      last_trade.ac_2_bars=last_signals.ac_2_bars_up_time[0];
      if(SendOrder(ORDER_TYPE_BUY,last_signals.ac_2_bars_up,last_signals.ac_2_bars_up_time,"TC_BW_2g_"+TimeToString(last_signals.ac_2_bars_up_time[0])))
        {actual_action.ac_2_bar_buy=false;return;}
     }
//--- 3-      
   if(actual_action.ac_3_bar_buy) //         C "  "
     {
      last_trade.ac_3_bars=last_signals.ac_3_bars_up_time[0];
      if(SendOrder(ORDER_TYPE_BUY,last_signals.ac_3_bars_up,last_signals.ac_3_bars_up_time,"TC_BW_3g_"+TimeToString(last_signals.ac_3_bars_up_time[0])))
        {actual_action.ac_3_bar_buy=false;return;}
     }
//---  
   if(actual_action.zone_buy) //         " "
     {
      last_trade.zone=last_signals.zone_up_time[0];
      if(SendOrder(ORDER_TYPE_BUY,last_signals.zone_up,last_signals.zone_up_time,"TC_BW_z_"+TimeToString(last_signals.zone_up_time[0])))
        {actual_action.zone_buy=false;return;}
     }
//---   2-  
   if(actual_action.line_balance_2_bar_buy) //          
     {
      last_trade.five_dimension=last_signals.five_dimension_2_bars_up_time[0];
      if(SendOrder(ORDER_TYPE_BUY,last_signals.five_dimension_2_bars_up,last_signals.five_dimension_2_bars_up_time,"BW_lb2_"+TimeToString(last_signals.five_dimension_2_bars_up_time[0])+DoubleToString(last_signals.five_dimension_2_bars_up[0],5)))
        { actual_action.line_balance_2_bar_buy=false;return;}
     }
//---   3-  
   if(actual_action.line_balance_3_bar_buy) //          
     {
      last_trade.five_dimension=last_signals.five_dimension_3_bars_up_time[0];
      if(SendOrder(ORDER_TYPE_BUY,last_signals.five_dimension_3_bars_up,last_signals.five_dimension_3_bars_up_time,"BW_lb3_"+TimeToString(last_signals.five_dimension_3_bars_up_time[0])+DoubleToString(last_signals.five_dimension_3_bars_up[0],5)))
        {actual_action.line_balance_3_bar_buy=false;return;}
     }

//---
//---      
//---
   if(actual_action.ao_bludce_sell) //          ""
     {
      last_trade.ao_blydce=last_signals.bludce_dn_time[0];
      if(SendOrder(ORDER_TYPE_SELL,last_signals.bludce_dn,last_signals.bludce_dn_time,"TC_BW_bl_"+TimeToString(last_signals.bludce_dn_time[0])))
        {actual_action.ao_bludce_sell=false;return;}
     }
   if(actual_action.ao_cross_zero_sell) //          "  "
     {
      last_trade.ao_cross_zero=last_signals.cross_zero_dn_time[0];
      if(SendOrder(ORDER_TYPE_SELL,last_signals.cross_zero_dn,last_signals.cross_zero_dn_time,"TC_BW_cz_"+TimeToString(last_signals.cross_zero_dn_time[0])))
        {actual_action.ao_cross_zero_sell=false;return;}
     }
//--- 2-      
   if(actual_action.ac_2_bar_sell) //         C "  "
     {
      last_trade.ac_2_bars=last_signals.ac_2_bars_dn_time[0];
      if(SendOrder(ORDER_TYPE_SELL,last_signals.ac_2_bars_dn,last_signals.ac_2_bars_dn_time,"TC_BW_2g_"+TimeToString(last_signals.ac_2_bars_dn_time[0])))
        {actual_action.ac_2_bar_sell=false;return;}
     }
//--- 3-      
   if(actual_action.ac_3_bar_sell) //         C "  "
     {
      last_trade.ac_3_bars=last_signals.ac_3_bars_dn_time[0];
      if(SendOrder(ORDER_TYPE_SELL,last_signals.ac_3_bars_dn,last_signals.ac_3_bars_dn_time,"TC_BW_3g_"+TimeToString(last_signals.ac_3_bars_dn_time[0])))
        {actual_action.ac_3_bar_sell=false;return;}
     }
//---  
   if(actual_action.zone_sell) //         " "
     {
      last_trade.zone=last_signals.zone_dn_time[0];
      if(SendOrder(ORDER_TYPE_SELL,last_signals.zone_dn,last_signals.zone_dn_time,"TC_BW_z_"+TimeToString(last_signals.zone_dn_time[0])))
        {actual_action.zone_sell=false;return;}
     }
//---   2-  
   if(actual_action.line_balance_2_bar_sell) //          
     {
      last_trade.five_dimension=last_signals.five_dimension_2_bars_dn_time[0];
      if(SendOrder(ORDER_TYPE_SELL,last_signals.five_dimension_2_bars_dn,last_signals.five_dimension_2_bars_dn_time,"BW_lb2_"+TimeToString(last_signals.five_dimension_2_bars_dn_time[0])+DoubleToString(last_signals.five_dimension_2_bars_dn[0],5)))
        {actual_action.line_balance_2_bar_sell=false;return;}
     }
//---   3-  
   if(actual_action.line_balance_3_bar_sell) //          
     {
      last_trade.five_dimension=last_signals.five_dimension_3_bars_dn_time[0];
      if(SendOrder(ORDER_TYPE_SELL,last_signals.five_dimension_3_bars_dn,last_signals.five_dimension_3_bars_dn_time,"BW_lb3_"+TimeToString(last_signals.five_dimension_3_bars_dn_time[0])+DoubleToString(last_signals.five_dimension_3_bars_dn[0],5)))
        {actual_action.line_balance_3_bar_sell=false;return;}
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//           
//  type -    (0- , 2 - , 3 -   )
//  countValue -    
//+------------------------------------------------------------------+
bool C_TS_BW::CopyIndValue(int type,int countValue)
  {
   int copyCount=-1;
   switch(type)
     {
      case 0: // 
         copyCount=CopyBuffer(h_alligator,0,inp_param.alligator_jaw_shift,countValue,jaw); // 
         //copyCount=CopyBuffer(h_alligator,0,0,countValue,jaw); // 
         if(copyCount<1){break;}
         copyCount=CopyBuffer(h_alligator,1,inp_param.alligator_teeth_shift,countValue,teeth); // 
         if(copyCount<1){break;}
         copyCount=CopyBuffer(h_alligator,2,inp_param.alligator_lips_shift,countValue,lips); // 
         if(copyCount<1){break;}
         break;
      case 2:     // AO
         copyCount=CopyBuffer(h_ao,0,0,countValue,AO_value);
         if(copyCount<1){break;}
         copyCount=CopyBuffer(h_ao,1,0,countValue,AO_color);
         if(copyCount<1){break;}
         break;
      case 3:     // AC
         copyCount=CopyBuffer(h_ac,0,0,countValue,AC_value);
         if(copyCount<1){break;}
         copyCount=CopyBuffer(h_ac,1,0,countValue,AC_color);
         if(copyCount<1){break;}
         break;
     }
   if(copyCount<1){return(false);}
   else{return(true);}

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|  //                               |
//+------------------------------------------------------------------+

bool C_TS_BW::FindSignal_1_dimension(int type,double &price_out[],datetime &time_out[])
  {
   int i,copyCount=-1;
   double tmp_buf[1];
   price_out[0]=-1;
   for(i=3;i<50;i++)
     {
      copyCount=CopyBuffer(h_fractals,type,i,1,tmp_buf);
      if(copyCount<1){return(false);}
      if(tmp_buf[0]!=EMPTY_VALUE && price_out[0]==-1)
        {
         price_out[0]=tmp_buf[0];
         CopyTime(m_Symbol,m_Period,i,1,time_out); //     
        }
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|    //                             |
//+------------------------------------------------------------------+
bool C_TS_BW::FindSignal_2_dimension(int type,int sub_type,double &price_out[],datetime &time_out[])
  {
   int copyCount=-1;
//    
   if((AO_value[1]>0 && AO_value[2]<0 && type==0 && sub_type==0) || //      
      (AO_color[1]==0 && AO_color[2]==1 && AO_value[2]>0 && type==0 && sub_type==1)) //    
     {
      CopyHigh(m_Symbol,m_Period,1,1,price_out);
      CopyTime(m_Symbol,m_Period,1,1,time_out);
     }
   if((AO_value[1]<0 && AO_value[2]>0 && type==1 && sub_type==0) || //     c  
      (AO_color[1]==1 && AO_color[2]==0 && AO_value[2]<0 && type==1 && sub_type==1)) //    
     {
      CopyLow(m_Symbol,m_Period,1,1,price_out);
      CopyTime(m_Symbol,m_Period,1,1,time_out);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
bool C_TS_BW::FindSignal_3_dimension(int type,int sub_type,double &price_out[],datetime &time_out[])
  {
   int copyCount=-1;
   if((AC_color[1]==0  &&  AC_value[1]>0  &&  AC_color[2]==0  &&  AC_color[3]==1  &&  type==0  &&  sub_type==0) || //()      
      (AC_color[1]==0 && AC_value[1]<0 && AC_color[2]==0 && AC_color[3]==0 && AC_color[4]==1 && type==0 && sub_type==1)) //()       (    )
     {
      copyCount=CopyHigh(m_Symbol,m_Period,1,1,price_out);
      if(copyCount<1){return(false);}
      CopyTime(m_Symbol,m_Period,1,1,time_out);
     }
   if((AC_color[1]==1  &&  AC_value[1]<0  &&  AC_color[2]==1  &&  AC_color[3]==0  &&  type==1  &&  sub_type==0) || //()      
      (AC_color[1]==1 && AC_value[1]>0 && AC_color[2]==1 && AC_color[3]==1 && AC_color[4]==0 && type==1 && sub_type==1)) //()       (    )
     {
      copyCount=CopyLow(m_Symbol,m_Period,1,1,price_out);
      if(copyCount<1){return(false);}
      CopyTime(m_Symbol,m_Period,1,1,time_out);

     }
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|   c                             |
//+------------------------------------------------------------------+
bool C_TS_BW::FindSignal_4_dimension(int type,int sub_type,double &price_out[],datetime &time_out[])
  {
   int copyCount=-1;
   bool find_green_zone=true,find_red_zone=true;
   bool limit_green_zone=true,limit_red_zone=true;
   double tmp_h[1],tmp_l[1]; //      
   if(sub_type==0) //      
     {
      copyCount=CopyClose(m_Symbol,m_Period,0,3,Close);
      if(copyCount<1){return(false);}
      if(AO_color[1]==0 && AO_color[2]==0 && AC_color[1]==0 && AC_color[2]==0 && Close[1]>Close[2] && type==0) //     
        {
         CopyHigh(m_Symbol,m_Period,1,1,price_out);
         CopyTime(m_Symbol,m_Period,1,1,time_out);
        }
      if(AO_color[1]==1 && AO_color[2]==1 && AC_color[1]==1 && AC_color[2]==1 && Close[1]<Close[2] && type==1) //    
        {
         CopyLow(m_Symbol,m_Period,1,1,price_out);
         CopyTime(m_Symbol,m_Period,1,1,time_out);
        }
     }
   if(sub_type==1) //    5-   
     {
      for(int y=1;y<=5;y++)
        {
         if(AO_color[y]==1 || AC_color[y]==1){find_green_zone=false;}
         if(AO_color[y]==0 || AC_color[y]==0){find_red_zone=false;}
        }
      if(find_green_zone && price_out[0]<0 && type==0)
        {
         CopyLow(m_Symbol,m_Period,1,1,price_out);  //             1-  ( )
        }
      if(find_red_zone && price_out[0]<0 && type==1)
        {
         CopyHigh(m_Symbol,m_Period,1,1,price_out); //             1-  ( )
        }
      //      (    )
      CopyHigh(m_Symbol,m_Period,1,1,tmp_h);
      CopyLow(m_Symbol,m_Period,1,1,tmp_l);
      if(price_out[0]>0 && type==0)
        {
         if(price_out[0]>tmp_l[0]){price_out[0]=-1;}           //      
         if(price_out[0]<tmp_l[0]){price_out[0]=tmp_l[0];}    //   
        }
      if(price_out[0]>0 && type==1)
        {
         if(price_out[0]<tmp_h[0]){price_out[0]=-1;}               //      
         if(price_out[0]>tmp_h[0]){price_out[0]=tmp_h[0];}         //   
        }
     }//if(sub_type==1)
   if(sub_type==2) //      
     {
      for(int t=1;t<=inp_param.max_4_dimension_zone;t++)
        {
         if((AO_color[t]==1 || AC_color[t]==1) && type==0){limit_green_zone=false;}
         if((AO_color[t]==0 || AC_color[t]==0) && type==1){limit_red_zone=false;}
        }
      if((limit_green_zone && type==0) || (limit_red_zone && type==1)){price_out[0]=-1;time_out[0]=-1;}
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
bool C_TS_BW::FindSignal_5_dimension(int type,int sub_type,double &price_out[],datetime &time_out[])
  {
   int copyCount=-1;
   int count_2_bars=0,count_3_bars=0,n;
   double high_tmp,low_tmp;
   price_out[0]=-1;
   time_out[0]=-1;
   if(type==0)
     {
      copyCount=CopyHigh(m_Symbol,m_Period,0,10,High);
      if(copyCount<1){return(false);}
      high_tmp=High[0];
      if(High[0]>jaw[0])
        {
         for(n=1;n<10;n++)
           {
            if(high_tmp<High[n]){high_tmp=High[n];count_2_bars++;count_3_bars++;}
            if((count_2_bars==1 && sub_type==0) || (count_3_bars==2 && sub_type==1))
              {
               price_out[0]=high_tmp;
               CopyTime(m_Symbol,m_Period,n,1,time_out);
               break;
              }
           }
        }
     }
   if(type==1)
     {
      copyCount=CopyLow(m_Symbol,m_Period,0,10,Low);
      if(copyCount<1){return(false);}
      low_tmp=Low[0];
      if(Low[0]<jaw[0])
        {
         for(n=1;n<10;n++)
           {
            if(low_tmp>Low[n]){low_tmp=Low[n];count_2_bars++;count_3_bars++;}
            if((count_2_bars==1 && sub_type==0) || (count_3_bars==2 && sub_type==1))
              {
               price_out[0]=low_tmp;
               CopyTime(m_Symbol,m_Period,n,1,time_out);
               break;
              }
           }
        }
     }

   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
bool C_TS_BW::CheckForTradeSignal(int dimension,int type,int sub_type,double &price_out[],datetime &time_out[])
  {
   int copyCount=-1;
   copyCount=CopyHigh(m_Symbol,m_Period,0,1,High);
   if(copyCount<1){return(false);}
   copyCount=CopyLow(m_Symbol,m_Period,0,1,Low);
   if(copyCount<1){return(false);}
   switch(dimension)
     {
      case 1:   //  
        {
         if((type==0 && High[0]>price_out[0] && High[0]<teeth[0] && price_out[0]>0) || //         -     
            (type==1 && Low[0]<price_out[0] && Low[0]>teeth[0] && price_out[0]>0)) //         -     
           {
            if(type==0){last_trade.fractal_up=time_out[0];}
            if(type==1){last_trade.fractal_dn=time_out[0];}
            time_out[0]=-1;
            price_out[0]=-1;
            return(false);
            break;
           }
         //--- 
         if(type==0                                   //   
            && High[0]>price_out[0]                   //         
            && time_out[0]!=last_trade.fractal_up     //      
            && High[0]>teeth[0]                       //        
            && price_out[0]>0)                        //      (   -1)
           {return(true);}                            //     
         //--- 
         if(type==1                                   //   C
            && Low[0]<price_out[0]                    //         
            && time_out[0]!=last_trade.fractal_dn     //      
            && Low[0]<teeth[0]                        //        
            && price_out[0]>0)                        //      (   -1)
           {return(true);}                            //     
         break;
        }
      case 2:   //    
        {
         if(High[0]>price_out[0] &&  High[0]>teeth[0] &&  price_out[0]>0  &&  type==0  &&  // 
            ((time_out[0]!=last_trade.ao_blydce && sub_type==1) ||                         // 
            (time_out[0]!=last_trade.ao_cross_zero && sub_type==0)))                       //   
           {return(true);}
         if(Low[0]<price_out[0] && Low[0]<teeth[0] && price_out[0]>0 && type==1 && // 
            ((time_out[0]!=last_trade.ao_blydce && sub_type==1) ||                         // 
            (time_out[0]!=last_trade.ao_cross_zero && sub_type==0)))                       //   
           {return(true);}
         break;
        }
      case 3:   //    C
        {
         if(High[0]>price_out[0] &&  High[0]>teeth[0] &&  price_out[0]>0  &&  type==0  &&  // 
            ((time_out[0]!=last_trade.ac_2_bars && sub_type==0) ||                         //    
            (time_out[0]!=last_trade.ac_3_bars && sub_type==1)))                           //    
           {
            if(AC_color[0]==1){price_out[0]=-1;time_out[0]=-1;return(false);}              //           -  
            else{return(true);}
           }
         if(Low[0]<price_out[0] && Low[0]<teeth[0] && price_out[0]>0 && type==1 && // 
            ((time_out[0]!=last_trade.ac_2_bars && sub_type==0) ||                         //    
            (time_out[0]!=last_trade.ac_3_bars && sub_type==1)))                           //    
           {
            if(AC_color[0]==0){price_out[0]=-1;time_out[0]=-1;return(false);}              //           -  
            else{return(true);}
           }
         break;
        }
      case 4:
        {
         if(High[0]>teeth[0]&& price_out[0]>0 && type==0 && time_out[0]!=last_trade.zone){return(true);}
         if(Low[0]<teeth[0] && price_out[0]>0 && type==1 && time_out[0]!=last_trade.zone){return(true);}
         break;
        }
      case 5:
        {
         if(High[0]>price_out[0] && High[0]>teeth[0] && price_out[0]>0 && type==0 && // 
            time_out[0]!=last_trade.five_dimension && 
            ((AO_color[0]==0 && AC_color[0]==0 && sub_type==0) ||   //     
            ((AO_color[0]==1 || AC_color[0]==1) && sub_type==1)))   //       
           {return(true);}
         if(Low[0]<price_out[0] && Low[0]<teeth[0] && price_out[0]>0 && type==1 && // 
            time_out[0]!=last_trade.five_dimension && 
            ((AO_color[0]==1 && AC_color[0]==1 && sub_type==0) ||   //      
            ((AO_color[0]==0 || AC_color[0]==0) && sub_type==1)))   //       

           {return(true);}
         break;
        }
      break;
     }
   return(false);//    false
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
bool C_TS_BW::SendOrder(ENUM_ORDER_TYPE type,double &price_out[],datetime &time_out[],string comment)
  {
//  
   bool needCalcMagic=true;
   //Print("mag=",(string) Magic," lot=",Lot);
   if(actual_action.fractal_open_buy || actual_action.fractal_open_sell){needCalcMagic=false;Magic=1000;actual_action.init();}
   if(actual_action.fractal_revers_buy_to_sell || actual_action.fractal_revers_sell_to_buy){needCalcMagic=false;Magic=999;actual_action.init();}
   if(needCalcMagic){CalcMagic(Magic);}

   exp_trade.SetExpertMagicNumber(Magic); //  
                                          //exp_trade.PrintRequest();
   double price,sl,tp=0.0;
   bool ret=false;
   s_info.RefreshRates();
//    

   if(Lot<0) //    
     {
      if(inp_param.agress_trade_mm)
        {
         if(Magic==1000){CalcLot(false,0.0,0);}  //  
         if(Magic==999){CalcLot(false,0.0,-1);}   // 
         if(Magic==1005){CalcLot(false,0.0,5);}   //  5
         if(Magic==1004){CalcLot(false,0.0,4);}   //  4
         if(Magic==1003){CalcLot(false,0.0,3);}   //  3
         if(Magic==1002){CalcLot(false,0.0,2);}   //  2
         if(Magic==1001){CalcLot(false,0.0,1);}   //  1
        }
      else
        {
         if(Magic>=1000 && Magic<=1005){CalcLot(false,0.0,1);}  //  
         if(Magic==999){CalcLot(false,0.0,-1);}   // 
        }
     }
   //Print("m=",(string) Magic," lot=",Lot);
   if(type==ORDER_TYPE_BUY)
     {
      price=s_info.Ask();
      //sl=NormalizeDouble(jaw[0],s_info.Digits());
      sl=0.0;
      if(exp_trade.PositionOpen(m_Symbol,ORDER_TYPE_BUY,Lot,price,sl,0.0,comment))
        {ret=true;}
     }
   if(type==ORDER_TYPE_SELL)
     {
      price=s_info.Bid();
      //sl=NormalizeDouble(jaw[0],s_info.Digits());
      sl=0.0;
      if(exp_trade.PositionOpen(m_Symbol,ORDER_TYPE_SELL,Lot,price,sl,0.0,comment))
        {ret=true;}
     }
   price_out[0]=-1; time_out[0]=-1;Lot=-1.0;

   if(ret)
     {
      if(actual_action.fractal_open_buy || actual_action.fractal_open_sell){actual_action.init();}
      if(actual_action.fractal_revers_buy_to_sell || actual_action.fractal_revers_sell_to_buy){actual_action.init();}
     }

   return(ret);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                    |
//+------------------------------------------------------------------+
void C_TS_BW::CalcLot(bool external,double ext_lot,int type)
  {
   if(external){Lot=ext_lot;return;}
   if(!external)
     {
      if(type==0) //  
        {if(inp_param.lot>0){Lot=inp_param.lot;}}
      if(type==-1) //   
        {if(inp_param.lot>0){Lot=inp_param.lot+pos_info.Volume();}}
      if(type==5) //  5
        {if(inp_param.lot>0){Lot=inp_param.lot*5;}}
      if(type==4) //  4
        {if(inp_param.lot>0){Lot=inp_param.lot*4;}}
      if(type==3) //  3
        {if(inp_param.lot>0){Lot=inp_param.lot*3;}}
      if(type==2) //  2
        {if(inp_param.lot>0){Lot=inp_param.lot*2;}}
      if(type==1) //  1
        {if(inp_param.lot>0){Lot=inp_param.lot*1;}}
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
void C_TS_BW::CheckActionOnTick(void)
  {
   bool select_pos=pos_info.Select(m_Symbol);
///       -           

   if(CheckForTradeSignal(1,0,0,last_signals.fractal_up,last_signals.fractal_up_time)) //         
     {
      if(!select_pos){actual_action.fractal_open_buy=true;} //    -   
      if(select_pos && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY && inp_param.add_1_dimension && last_signals.alligator_trend[0]){actual_action.fractal_add_buy=true;} //     Buy-   
      if(select_pos && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL){actual_action.fractal_revers_sell_to_buy=true;} //     Sell -    
     }
   if(CheckForTradeSignal(1,1,0,last_signals.fractal_dn,last_signals.fractal_dn_time)) //         
     {
      if(!select_pos){actual_action.fractal_open_sell=true;} //    -   
      if(select_pos && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL && inp_param.add_1_dimension  && last_signals.alligator_trend[1]){actual_action.fractal_add_sell=true;} //     Sell-   
      if(select_pos && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY){actual_action.fractal_revers_buy_to_sell=true;} //     Buy -    
     }
//---  2-5  buy
   if(select_pos && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_BUY) ///       
     {
      //---         
      if(inp_param.add_2_dimension_bludce && CheckForTradeSignal(2,0,1,last_signals.bludce_up,last_signals.bludce_up_time)) //          ""
        {actual_action.ao_bludce_buy=true;}
      //---             
      if(inp_param.add_2_dimension_cross_zero && CheckForTradeSignal(2,0,0,last_signals.cross_zero_up,last_signals.cross_zero_up_time)) //          "  "
        {actual_action.ao_cross_zero_buy=true;}
      //--- 2-      
      if(inp_param.add_3_dimension_use_2_bars && CheckForTradeSignal(3,0,0,last_signals.ac_2_bars_up,last_signals.ac_2_bars_up_time)) //         C "  "
        {actual_action.ac_2_bar_buy=true;}
      //--- 3-      
      if(inp_param.add_3_dimension_use_3_bars && CheckForTradeSignal(3,0,1,last_signals.ac_3_bars_up,last_signals.ac_3_bars_up_time)) //         C "  "
        {actual_action.ac_3_bar_buy=true;}
      //---  
      if(inp_param.add_4_dimension_zone && CheckForTradeSignal(4,0,0,last_signals.zone_up,last_signals.zone_up_time)) //         AO + AC ( )
        {actual_action.zone_buy=true;}
      //---      
      if(inp_param.add_5_dimension && CheckForTradeSignal(5,0,0,last_signals.five_dimension_2_bars_up,last_signals.five_dimension_2_bars_up_time)) //            
        {actual_action.line_balance_2_bar_buy=true;}
      //---      
      if(inp_param.add_5_dimension && CheckForTradeSignal(5,0,1,last_signals.five_dimension_3_bars_up,last_signals.five_dimension_3_bars_up_time)) //            
        {actual_action.line_balance_3_bar_buy=true;}

     }
//---   2-5  sell
   if(select_pos && (ENUM_POSITION_TYPE)pos_info.PositionType()==POSITION_TYPE_SELL) ///       
     {
      //--- 
      if(inp_param.add_2_dimension_bludce && CheckForTradeSignal(2,1,1,last_signals.bludce_dn,last_signals.bludce_dn_time)) //          ""
        {actual_action.ao_bludce_sell=true;}
      //---   
      if(inp_param.add_2_dimension_cross_zero && CheckForTradeSignal(2,1,0,last_signals.cross_zero_dn,last_signals.cross_zero_dn_time)) //          "  "
        {actual_action.ao_cross_zero_sell=true;}
      //--- 2-      
      if(inp_param.add_3_dimension_use_2_bars && CheckForTradeSignal(3,1,0,last_signals.ac_2_bars_dn,last_signals.ac_2_bars_dn_time)) //         C "  "
        {actual_action.ac_2_bar_sell=true;}
      //--- 3-      
      if(inp_param.add_3_dimension_use_3_bars && CheckForTradeSignal(3,1,1,last_signals.ac_3_bars_dn,last_signals.ac_3_bars_dn_time)) //         C "  "
        {actual_action.ac_3_bar_sell=true;}
      //--- 
      if(inp_param.add_4_dimension_zone && CheckForTradeSignal(4,1,0,last_signals.zone_dn,last_signals.zone_dn_time)) //         AO + AC ( )
        {actual_action.zone_sell=true;}
      //---      
      if(inp_param.add_5_dimension && CheckForTradeSignal(5,1,0,last_signals.five_dimension_2_bars_dn,last_signals.five_dimension_2_bars_dn_time)) //            
        {actual_action.line_balance_2_bar_sell=true;}
      //---      
      if(inp_param.add_5_dimension && CheckForTradeSignal(5,1,1,last_signals.five_dimension_3_bars_dn,last_signals.five_dimension_3_bars_dn_time)) //            
        {actual_action.line_balance_3_bar_sell=true;}
     }
   return;
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
ulong C_TS_BW::CalcMagic(ulong  &magic)
  {
   if(magic==-1) //    
     {
      HistorySelect(TimeCurrent()-PeriodSeconds(PERIOD_MN1)*3,TimeCurrent());
      int countHistoryOrders=HistoryOrdersTotal();
      for(int n=countHistoryOrders-1;n>=0;n++)
        {
         h_info.SelectByIndex(n);
         magic=h_info.Magic();
         if(magic>0 && h_info.Symbol()==m_Symbol && magic>1000 && magic<=1005)
           {
            break;
           }
        }
     }
//   
   switch(magic)
     {
      case 999: //      
        {magic=1005;break;}
      case 1000: // //        
        {magic=1005;break;}
      case 1005: //           (  inp_param.agress_trade_mm  5 )
        {magic=1004;break;}
      case 1004: //           (  inp_param.agress_trade_mm 4  )
        {magic=1003;break;}
      case 1003: //           (  inp_param.agress_trade_mm 3  )
        {magic=1002;break;}
      case 1002: //           (  inp_param.agress_trade_m m 2`  )
        {magic=1001;break;}
      case 1001: //             (  inp_param.agress_trade_mm  1  )
        {magic=1001;break;}
     }
   return(magic);
  }
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void C_TS_BW::SetStopLoss(double &stoploss)
  {StopLoss=stoploss;return;}

//+------------------------------------------------------------------+
//|                                                                   |
//+------------------------------------------------------------------+
